// Rob McDermott			6 August 2004
// 159.776 Visual Languages and Graphics	Assignment 3
// 3D, interactive, animated, illuminated and textured 'IIST'
// Keyboard events allow the user to move through a world containing
// the letters 'IIST'.
// -------------------------------------------------------------

#pragma hdrstop
#include <condefs.h>
#include <iostream.h>
#include <windows.h>
#include <math.h>
#include <stdio.h>
#include <gl/Gl.h>
#include <gl/glut.h>

//---------------------------------------------------------------------------
#pragma argsused

#define cube 1 		// identifier for the list of commands that draws a cube
#define floor 2 	// id for list of commands for floor
#define wall 3 	// id for list of commands for a wall
#define ceiling 4
#define PI 3.1415926535898

// variable declarations ---------------------------

GLuint  window, viewingWindow, textWindow;	// variables to identify the window
const float piover180 = 0.0174532925f;
float heading, xpos;
float zpos = 5.0;				// initially locate viewer 5 units back from objects
GLfloat	yrot;
GLfloat walkbias = 0.0;
GLfloat walkbiasangle = 0.0;
GLfloat lookupdown = 0.0;
GLfloat light0_pos[] ={0.0,1.5,10.0,1.0};	// light is a point source
//GLfloat light0_pos[] ={4.0,3.0,6.0,0.0};	// light is a distant source
enum materialTypes {iistLetters,theFloor,theWalls,theCeiling,theLight} myMaterial; //e.g myMaterial = theFloor
GLuint texture;		// Storage for a texture
GLuint texture1;
int Width, Height;
unsigned int wallTexId, floorTexId, iistTexId, ceilingTexId;
GLfloat lightRotation = 0.0;

// global data -------------------------------------

	// array of vertices for a cube
	GLfloat cubeVertices[ ][3] = {  {-1.0,-1.0,-1.0},
    								{1.0,-1.0,-1.0},
                                	{1.0,1.0,-1.0},
                                	{-1.0,1.0,-1.0},
                                	{-1.0,-1.0,1.0},
                                	{1.0,-1.0,1.0},
                                	{1.0,1.0,1.0},
                                	{-1.0,1.0,1.0}};

	// array of normal vectors for a cube
	GLfloat cubeNormals[ ][3] = {  {-1.0,-1.0,-1.0},
    								{1.0,-1.0,-1.0},
                                	{1.0,1.0,-1.0},
                                	{-1.0,1.0,-1.0},
                                	{-1.0,-1.0,1.0},
                                	{1.0,-1.0,1.0},
                                	{1.0,1.0,1.0},
                                	{-1.0,1.0,1.0}};

	// array of colours for cube vertices
	GLfloat cubeColors[ ][3] = {    {0.0,0.0,0.0},
    								{1.0,0.0,0.0},
                                    {1.0,1.0,0.0},
                                    {0.0,1.0,0.0},
                                    {0.0,0.0,1.0},
                                    {1.0,0.0,1.0},
                                    {1.0,1.0,1.0},
                                    {0.0,1.0,1.0}};

	// material properties
	GLfloat mat_specular[][4]={ {0.6,0.5,0.2,1.0}, // IIST material
								{0.9,0.9,0.9,1.0}, // floor material
                                {0.7,0.8,0.9,1.0}, // wall material
                                {0.9,0.9,0.9,1.0}, // ceiling material
                                {1.0,1.0,1.0,1.0}}; // the light source
	GLfloat mat_diffuse[][4]= { {0.8,0.6,0.4,1.0}, // IIST material
								{0.4,0.9,0.4,1.0}, // floor material
                                {0.4,0.5,0.9,1.0}, // wall material
                                {0.9,0.9,0.9,1.0}, // ceiling material
                                {1.0,1.0,1.0,1.0}}; // the light source
    GLfloat mat_ambient[][4]={  {0.6,0.4,0.5,1.0}, // IIST material
								{0.3,0.8,0.3,1.0}, // floor material
                                {0.2,0.5,0.8,1.0}, // wall material
                                {0.9,0.9,0.9,0.2}, // ceiling material
                                {1.0,1.0,1.0,1.0}}; // the light source
    GLfloat mat_shininess[5]={  60.0, // IIST material
								40.0, // floor material
                                100.0, // wall material
                                70.0, // ceiling material
                                100.0}; // the light source
	GLfloat mat_emission[][4]={ {0.0,0.0,0.0,1.0}, // IIST material
								{0.0,0.0,0.0,1.0}, // floor material
                                {0.0,0.0,0.0,1.0}, // wall material
                                {0.0,0.0,0.0,1.0}, // ceiling material
                                {1.0,1.0,1.0,1.0}}; // the light source
                                        

// function declarations
void setMaterial(int type);
void redisplayAll(void);
void drawstr(GLvoid *font, GLfloat x, GLfloat y, char* format, ...);
bool NeHeLoadBitmap(LPTSTR szFileName, GLuint &texid);
void floorTexture(void);
void cubeObject(void);

// function implementation ------------------------------------------


void myReshape(int w, int h)
{
	/* NB: setting up a perspective viewing volume:
     * glFrustum(xmin,xmax,ymin,ymax,near,far) where...
     * near and far distances must both be positive, and are measured
     * from the centre of projection (the centre of the camera lens/eye)
     */

	glViewport(0,0,w,h);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    if (w<=h)
    	glFrustum(-2.0,2.0,-2.0*(GLfloat)h/(GLfloat)w,2.0*(GLfloat)h/(GLfloat)w,2.0,40.0);
    else
        glFrustum(-2.0,2.0,-2.0*(GLfloat)w/(GLfloat)h,2.0*(GLfloat)w/(GLfloat)h,2.0,40.0);
    
    glMatrixMode(GL_MODELVIEW);
}

void textReshape(int w, int h)
{
	glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
   	gluOrtho2D(0.0,300,0.0,100);  //xMin,xMax,yMin,yMax
    glMatrixMode(GL_MODELVIEW);
}

void cubeObject(void)
{
    glBegin(GL_QUADS);				// Start Drawing Quads
        // Front Face
		glNormal3f( 0.0f, 0.0f, 1.0f);					// Normal pointing towards viewer
		glTexCoord2f(0.0f, 0.0f); glVertex3f(-1.0f, -1.0f,  1.0f);	// Point 1 (Front)
		glTexCoord2f(1.0f, 0.0f); glVertex3f( 1.0f, -1.0f,  1.0f);	// Point 2 (Front)
		glTexCoord2f(1.0f, 1.0f); glVertex3f( 1.0f,  1.0f,  1.0f);	// Point 3 (Front)
		glTexCoord2f(0.0f, 1.0f); glVertex3f(-1.0f,  1.0f,  1.0f);	// Point 4 (Front)
		// Back Face
		glNormal3f( 0.0f, 0.0f,-1.0f);					// Normal pointing away from viewer
		glTexCoord2f(1.0f, 0.0f); glVertex3f(-1.0f, -1.0f, -1.0f);	// Point 1 (Back)
		glTexCoord2f(1.0f, 1.0f); glVertex3f(-1.0f,  1.0f, -1.0f);	// Point 2 (Back)
		glTexCoord2f(0.0f, 1.0f); glVertex3f( 1.0f,  1.0f, -1.0f);	// Point 3 (Back)
		glTexCoord2f(0.0f, 0.0f); glVertex3f( 1.0f, -1.0f, -1.0f);	// Point 4 (Back)
		// Top Face
		glNormal3f( 0.0f, 1.0f, 0.0f);					// Normal pointing up
		glTexCoord2f(0.0f, 1.0f); glVertex3f(-1.0f,  1.0f, -1.0f);	// Point 1 (Top)
		glTexCoord2f(0.0f, 0.0f); glVertex3f(-1.0f,  1.0f,  1.0f);	// Point 2 (Top)
		glTexCoord2f(1.0f, 0.0f); glVertex3f( 1.0f,  1.0f,  1.0f);	// Point 3 (Top)
		glTexCoord2f(1.0f, 1.0f); glVertex3f( 1.0f,  1.0f, -1.0f);	// Point 4 (Top)
		// Bottom Face
		glNormal3f( 0.0f,-1.0f, 0.0f);					// Normal pointing down
		glTexCoord2f(1.0f, 1.0f); glVertex3f(-1.0f, -1.0f, -1.0f);	// Point 1 (Bottom)
		glTexCoord2f(0.0f, 1.0f); glVertex3f( 1.0f, -1.0f, -1.0f);	// Point 2 (Bottom)
		glTexCoord2f(0.0f, 0.0f); glVertex3f( 1.0f, -1.0f,  1.0f);	// Point 3 (Bottom)
		glTexCoord2f(1.0f, 0.0f); glVertex3f(-1.0f, -1.0f,  1.0f);	// Point 4 (Bottom)
		// Right face
		glNormal3f( 1.0f, 0.0f, 0.0f);					// Normal pointing right
		glTexCoord2f(1.0f, 0.0f); glVertex3f( 1.0f, -1.0f, -1.0f);	// Point 1 (Right)
		glTexCoord2f(1.0f, 1.0f); glVertex3f( 1.0f,  1.0f, -1.0f);	// Point 2 (Right)
		glTexCoord2f(0.0f, 1.0f); glVertex3f( 1.0f,  1.0f,  1.0f);	// Point 3 (Right)
		glTexCoord2f(0.0f, 0.0f); glVertex3f( 1.0f, -1.0f,  1.0f);	// Point 4 (Right)
		// Left Face
		glNormal3f(-1.0f, 0.0f, 0.0f);					// Normal pointing left
		glTexCoord2f(0.0f, 0.0f); glVertex3f(-1.0f, -1.0f, -1.0f);	// Point 1 (Left)
		glTexCoord2f(1.0f, 0.0f); glVertex3f(-1.0f, -1.0f,  1.0f);	// Point 2 (Left)
		glTexCoord2f(1.0f, 1.0f); glVertex3f(-1.0f,  1.0f,  1.0f);	// Point 3 (Left)
		glTexCoord2f(0.0f, 1.0f); glVertex3f(-1.0f,  1.0f, -1.0f);	// Point 4 (Left)
	glEnd();
}

	// a polygon that will form the floor of the world
void floorObject(void)
{
	/* create vertices in anti-clockwise order to have the polygon facing you
     * bottom left, bottom right, top right, top left  (counter-clockwise).
     * By drawing in a counter clockwise order, the square will be facing us.
     * This means we can cull back faces to save processing effort...
     */
    glBegin(GL_POLYGON);
	    // Top Face
		glNormal3f( 0.0f, 1.0f, 0.0f);					// Normal pointing up
		glTexCoord2f(-1.0f, 2.0f); glVertex3f(-1.0f,  1.0f, -1.0f);	// Point 1 (Top)
		glTexCoord2f(-1.0f, -1.0f); glVertex3f(-1.0f,  1.0f,  1.0f);	// Point 2 (Top)
		glTexCoord2f(2.0f, -1.0f); glVertex3f( 1.0f,  1.0f,  1.0f);	// Point 3 (Top)
		glTexCoord2f(2.0f, 2.0f); glVertex3f( 1.0f,  1.0f, -1.0f);	// Point 4 (Top)
    glEnd();
}

	// a polygon that will form the ceiling of the world
void ceilingObject(void)
{
	/* create vertices in anti-clockwise order to have the polygon facing you
     * bottom left, bottom right, top right, top left  (counter-clockwise).
     * By drawing in a counter clockwise order, the square will be facing us.
     * This means we can cull back faces to save processing effort...
     */
    glBegin(GL_POLYGON);
	    // Bottom Face
		glNormal3f( 0.0f,-1.0f, 0.0f);					// Normal pointing down
		glTexCoord2f(2.0f, 2.0f); glVertex3f(-1.0f, -1.0f, -1.0f);	// Point 1 (Bottom)
		glTexCoord2f(-1.0f, 2.0f); glVertex3f( 1.0f, -1.0f, -1.0f);	// Point 2 (Bottom)
		glTexCoord2f(-1.0f, -1.0f); glVertex3f( 1.0f, -1.0f,  1.0f);	// Point 3 (Bottom)
		glTexCoord2f(2.0f, -1.0f); glVertex3f(-1.0f, -1.0f,  1.0f);	// Point 4 (Bottom)
    glEnd();
}

	// a polygon that will form the walls of the world
void wallObject(void)
{
	glBegin(GL_POLYGON);
		// Front Face
		glNormal3f( 0.0f, 0.0f, 1.0f);					// Normal pointing towards viewer
		glTexCoord2f(0.0f, -2.0f); glVertex3f(-1.0f, -1.0f,  0.0f);	// Point 1 (Front)
		glTexCoord2f(1.0f, -2.0f); glVertex3f( 1.0f, -1.0f,  0.0f);	// Point 2 (Front)
		glTexCoord2f(1.0f, 2.0f); glVertex3f( 1.0f,  1.0f,  0.0f);	// Point 3 (Front)
		glTexCoord2f(0.0f, 2.0f); glVertex3f(-1.0f,  1.0f,  0.0f);	// Point 4 (Front)
	glEnd();
}

/*
 * Create the 3D objects making up the IIST logo
 */
void createObjects() {
	// Create a display list for the IIST logo
	glNewList(cube, GL_COMPILE);
    	cubeObject(); // generates a series of GL_POLYGONs for faces of a cube
    glEndList();

    // display list for the floor
    glNewList(floor, GL_COMPILE);
    	floorObject();
    glEndList();

    // display list for the ceiling
    glNewList(ceiling, GL_COMPILE);
    	ceilingObject();
    glEndList();

    // display list for a wall
    glNewList(wall, GL_COMPILE);
    	wallObject();
    glEndList();
}

void initTextures(void)
{
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);

	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST_MIPMAP_NEAREST);

    floorTexture();	// create the checkerboard texture for the floor

	// now create the wall & ceiling textures using function by NeHe to read bitmaps
	if (!NeHeLoadBitmap("corrigatedIronTexture.bmp", wallTexId))
    	cout << "failed to load bitmap for wall texture" << endl;
	if (!NeHeLoadBitmap("leopard.bmp", iistTexId))
    	cout << "failed to load bitmap for iist texture" << endl;
	if (!NeHeLoadBitmap("concrete.bmp", ceilingTexId))
    	cout << "failed to load bitmap for ceiling texture" << endl;

	//glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE); // texture replaces shading effects
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE); // texture takes account of shading effects
    glHint(GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST); // improve texure mapping to perspective surfaces
}

/************************************************************************
     REPLACEMENT FOR GLAUX by NeHe http://nehe.gamedev.net/
 ************************************************************************
	This is not a full blown bitmap loader.  It is a quick and easy
	way to replace the glAux dependant code in my older tutorials
	with code that does not depend on the glAux library!

    This code only loads Truecolor Bitmap Images.  It will not load
	8-bit bitmaps.  If you encounter a bitmap that will not load
	use a program such as Irfanview to convert the bitmap to 24 bits.
 ************************************************************************/
bool NeHeLoadBitmap(LPTSTR szFileName, GLuint &texid)					// Creates Texture From A Bitmap File
{
	HBITMAP hBMP;														// Handle Of The Bitmap
	BITMAP	BMP;														// Bitmap Structure

	glGenTextures(1, &texid);											// Create The Texture
	hBMP=(HBITMAP)LoadImage(GetModuleHandle(NULL), szFileName, IMAGE_BITMAP, 0, 0, LR_CREATEDIBSECTION | LR_LOADFROMFILE );

	if (!hBMP)															// Does The Bitmap Exist?
		return FALSE;													// If Not Return False

	GetObject(hBMP, sizeof(BMP), &BMP);									// Get The Object
																		// hBMP:        Handle To Graphics Object
																		// sizeof(BMP): Size Of Buffer For Object Information
																		// &BMP:        Buffer For Object Information

	glPixelStorei(GL_UNPACK_ALIGNMENT, 4);								// Pixel Storage Mode (Word Alignment / 4 Bytes)

	// Typical Texture Generation Using Data From The Bitmap
	glBindTexture(GL_TEXTURE_2D, texid);								// Bind To The Texture ID
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);	// Linear Min Filter
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);	// Linear Mag Filter
	glTexImage2D(GL_TEXTURE_2D, 0, 3, BMP.bmWidth, BMP.bmHeight, 0, GL_BGR_EXT, GL_UNSIGNED_BYTE, BMP.bmBits);

	DeleteObject(hBMP);													// Delete The Object

	return TRUE;														// Loading Was Successful
} // end of NeHe stuff

	 // checkerboard texture settings ( from Edward Angel)
void floorTexture(void)
{
   GLubyte image[64][64][3];
   int i, j, r, c;
   for(i=0;i<64;i++)
   {
      for(j=0;j<64;j++)
      {
	 c = ((((i&0x8)==0)^((j&0x8))==0))*255;
	 image[i][j][0]= (GLubyte) c;
	 image[i][j][1]= (GLubyte) c;
	 image[i][j][2]= (GLubyte) c;
      }
   }
   glPixelStorei(GL_UNPACK_ALIGNMENT,1);
   glBindTexture(GL_TEXTURE_2D, floorTexId);
   glTexImage2D(GL_TEXTURE_2D,0,3,64,64,0,GL_RGB,GL_UNSIGNED_BYTE, image);
   glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
   glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
   gluBuild2DMipmaps(GL_TEXTURE_2D,3,64,64,GL_RGB,GL_UNSIGNED_BYTE, image);
}

void redisplayAll(void)
{
    glutSetWindow(viewingWindow);
    glutPostRedisplay();
}

void display(void)
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	// Clear The Screen And The Depth Buffer
	glLoadIdentity();

    // tweak the matrix... to move the viewer around the scene (actually, move the scene around viewer)
    GLfloat xtrans = -xpos;
	GLfloat ztrans = -zpos;
	GLfloat ytrans = -walkbias-0.25f;
	GLfloat sceneroty = 360.0f - yrot;
	glRotatef(lookupdown,1.0f,0,0);
	glRotatef(sceneroty,0,1.0f,0);
	glTranslatef(xtrans, ytrans, ztrans);
    

    // and now draw the desired objects...

    // 0. the light source
    	// a cube centred on the location of the light source
	    // and which flies around the room...
    glDisable(GL_TEXTURE_2D); // don't texture the light
    myMaterial = theLight;
 	setMaterial(myMaterial);
    glPushMatrix();
    glRotatef(lightRotation,0,1.0f,0); // spins around room during idle()...
    glTranslatef(light0_pos[0],light0_pos[1],light0_pos[2]);
    glScalef(0.2,0.2,0.5);
    glCallList(cube);
    glLightfv(GL_LIGHT0,GL_POSITION,light0_pos); // light is a point source
	glPopMatrix();

    // Now the IIST letters...
	myMaterial = iistLetters;
 	setMaterial(myMaterial);

    glEnable(GL_TEXTURE_2D);
    glBindTexture( GL_TEXTURE_2D, iistTexId);

    // 1. the first 'I'
    glPushMatrix();	// preserve matrix while we translate the first I
    glTranslatef(-4.0,0.0,0.0);	// first I appears to the left of the central point
    glScalef(0.5,3.0,0.5);	// scale in the x,y,z coordinate
    glCallList(cube); // list of commands to construct a cube
    glPopMatrix();	// restore matrix

    // 2. the second 'I'
    glPushMatrix();
    glTranslatef(-2.0,0.0,0.0);	// second I appears to the right of first I, but still left of central point
    glScalef(0.5,3.0,0.5);
    glCallList(cube);
    glPopMatrix();

    // 3. the 'S'
		// top crossbar
    glPushMatrix();
    glTranslatef(0.5,2.5,0.0);
    glScalef(1.5,0.5,0.5);
    glCallList(cube);
    glPopMatrix();
		// middle crossbar
    glPushMatrix();
    glTranslatef(0.5,0.0,0.0);
    glScalef(1.5,0.5,0.5);
    glCallList(cube);
    glPopMatrix();
		// bottom crossbar
    glPushMatrix();
    glTranslatef(0.5,-2.5,0.0);
    glScalef(1.5,0.5,0.5);
    glCallList(cube);
    glPopMatrix();
		// top upright
    glPushMatrix();
    glTranslatef(-0.5,1.5,0.0);
    glScalef(0.5,1.5,0.5);
    glCallList(cube);
    glPopMatrix();
		// bottom upright
    glPushMatrix();
    glTranslatef(1.5,-1.5,0.0);
    glScalef(0.5,1.5,0.5);
    glCallList(cube);
    glPopMatrix();

    // 4. the 'T'
    	// upright
    glPushMatrix();
    glTranslatef(4.0,0.0,0.0);	// T appears to the right of the S
    glScalef(0.5,3.0,0.5);
    glCallList(cube);
    glPopMatrix();
		// crossbar
    glPushMatrix();
    glTranslatef(4.0,2.5,0.0);
    glScalef(1.5,0.5,0.5);
    glCallList(cube);
    glPopMatrix();

    //5. the floor
    	// apply texture to the floor
    glEnable(GL_TEXTURE_2D);
    glBindTexture( GL_TEXTURE_2D, floorTexId);

		// specify the material properties of the floor
	myMaterial = theFloor;
 	setMaterial(myMaterial);
    	// lay the floor down
	glPushMatrix();
    glTranslatef(0.0,-3.0,0.0);
    glScalef(10.0,0.0,10.0);
    glCallList(floor);
    glPopMatrix();

    //6. the walls
    glBindTexture( GL_TEXTURE_2D, wallTexId);

		// specify the material properties of the walls
	myMaterial = theWalls;
 	setMaterial(myMaterial);

    	// left wall
	glPushMatrix();
    glTranslatef(-10.0,0.0,0.0);
    glRotatef(90.0,0.0,1.0,0.0);
    glScalef(10.0,3.0,1.0);
    glCallList(wall);
    glPopMatrix();

    	// far wall
	glPushMatrix();
    glTranslatef(0.0,0.0,-10.0);
    glScalef(10.0,3.0,1.0);
    glCallList(wall);
    glPopMatrix();

    	// right wall
	glPushMatrix();
    glTranslatef(10.0,0.0,0.0);
    glRotatef(-90.0,0.0,1.0,0.0);
    glScalef(10.0,3.0,1.0);
    glCallList(wall);
    glPopMatrix();
    	// rear wall
	glPushMatrix();
    glTranslatef(0.0,0.0,10.0);
    glRotatef(180.0,0.0,1.0,0.0);
    glScalef(10.0,3.0,1.0);
    glCallList(wall);
    glPopMatrix();

    //7. the ceiling
    glBindTexture( GL_TEXTURE_2D, ceilingTexId);
		// specify the material properties of the ceiling
	myMaterial = theCeiling;
 	setMaterial(myMaterial);
       	// hang the ceiling up
	glPushMatrix();
    glTranslatef(0.0,3.0,0.0);
    glScalef(10.0,0.0,10.0);
    glCallList(ceiling);
    glPopMatrix();

	glFlush();
	glutSwapBuffers();
}

void mainDisplay(void)
{
	glClearColor(0.6,0.6,0.6,0.0);	//background - grey
	glClear(GL_COLOR_BUFFER_BIT);	// Clear The Screen And The Depth Buffer
	glLoadIdentity();

    glFlush();
	glutSwapBuffers();
}

void textDisplay(void)
{
	glClearColor(0.3,0.3,0.3,0.0);	//background - grey
	glClear(GL_COLOR_BUFFER_BIT);	// Clear The Screen And The Depth Buffer
	glLoadIdentity();

	glColor3f(0.0f,1.0f,0.0f);		// green
    drawstr(GLUT_BITMAP_HELVETICA_12,20.0,75.0,"    Arrow keys: up/down to walk forward/back");
    drawstr(GLUT_BITMAP_HELVETICA_12,20.0,50.0,"                    : left/right to turn");
    drawstr(GLUT_BITMAP_HELVETICA_12,20.0,25.0,"Page up/down: tilt head up/down");

	glFlush();
	glutSwapBuffers();
}

void drawstr(GLvoid *font, GLfloat x, GLfloat y, char* format, ...)
{
    va_list args;
    char buffer[255], *s;

    va_start(args, format);
    vsprintf(buffer, format, args);
    va_end(args);

    glRasterPos2f(x, y);
    for (s = buffer; *s; s++)
        glutBitmapCharacter(font, *s);
}

	/* left and right arrow keys control the direction the viewer is moving
     * up and down arrows determine whether they move forwards or backwards
     */
void arrowKeys(int key, int x, int y)
{
	if (key == GLUT_KEY_RIGHT)
	{
		yrot -= 1.5f;							// Rotate The Scene To The Left
	}

	if (key == GLUT_KEY_LEFT)
	{
		yrot += 1.5f;							// Rotate The Scene To The Right
	}
	heading = yrot;
	if (key == GLUT_KEY_UP)
	{
		xpos -= (float)sin(heading*piover180) * 0.05f;			// Move On The X-Plane Based On Player Direction
		zpos -= (float)cos(heading*piover180) * 0.05f;			// Move On The Z-Plane Based On Player Direction
		if (walkbiasangle >= 359.0f)					// Is walkbiasangle>=359?
		{
			walkbiasangle = 0.0f;					// Make walkbiasangle Equal 0
		}
		else										// Otherwise
		{
			 walkbiasangle+= 30;					// If walkbiasangle < 359 Increase It By 10
		}
		walkbias = (float)sin(walkbiasangle * piover180)/10.0f;		// Causes The Player To Bounce
	}

	if (key == GLUT_KEY_DOWN)
	{
		xpos += (float)sin(heading*piover180) * 0.05f;			// Move On The X-Plane Based On Player Direction
		zpos += (float)cos(heading*piover180) * 0.05f;			// Move On The Z-Plane Based On Player Direction
		if (walkbiasangle <= 1.0f)					// Is walkbiasangle<=1?
		{
			walkbiasangle = 359.0f;					// Make walkbiasangle Equal 359
		}
		else								// Otherwise
		{
			walkbiasangle-= 30;					// If walkbiasangle > 1 Decrease It By 10
		}
		walkbias = (float)sin(walkbiasangle * piover180)/10.0f;		// Causes The Player To Bounce
    }

    if (key == GLUT_KEY_PAGE_DOWN)   // pgDown makes you tilt head downwards
    {
		lookupdown+= 1.0f;
	}
    if (key == GLUT_KEY_PAGE_UP)	// pgUp makes you tilt head upwards
	{
		lookupdown-= 1.0f;
	}
    redisplayAll();
}

/* set the material for the specified type, which is an index
 * for a predefined array of material properties
 * e.g. myMaterial = theFloor;
 * then call: setMaterial(myMaterial);
 */
void setMaterial(int type)
{
	glMaterialfv(GL_FRONT,GL_SPECULAR,mat_specular[type]);
    glMaterialfv(GL_FRONT,GL_AMBIENT,mat_ambient[type]);
    glMaterialfv(GL_FRONT,GL_DIFFUSE,mat_diffuse[type]);
    glMaterialf(GL_FRONT,GL_SHININESS,mat_shininess[type]);

    glMaterialfv(GL_FRONT_AND_BACK,GL_EMISSION,mat_emission[type]);
}

	// setup properties for lighting
void myInit(void)
{
    GLfloat light_ambient[]={0.1,0.1,0.1,1.0};
    GLfloat light_diffuse[]={0.6,0.6,0.6,1.0};
    GLfloat light_specular[]={0.8,0.8,0.8,1.0};

    glLightfv(GL_LIGHT0,GL_POSITION,light0_pos);
    glLightfv(GL_LIGHT0,GL_AMBIENT,light_ambient);
    glLightfv(GL_LIGHT0,GL_DIFFUSE,light_diffuse);
    glLightfv(GL_LIGHT0,GL_SPECULAR,light_specular);

    glEnable(GL_SMOOTH);	// smooth shading
    glEnable(GL_LIGHTING);	// enable lighting
    glEnable(GL_LIGHT0);	//turn this particular light on
    glEnable(GL_DEPTH_TEST);

    glEnable(GL_NORMALIZE);	// adjust normals after scaling objects

    // anti-aliasing
    glEnable(GL_POINT_SMOOTH);
	glEnable(GL_LINE_SMOOTH);
    glEnable(GL_POLYGON_SMOOTH);
    glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);

    // cull back-faces
    glCullFace(GL_BACK);
    glEnable(GL_CULL_FACE);

    glEnable(GL_TEXTURE_2D);
}

void idle(void)	// spin the light around perimeter of room during idle()
{
	lightRotation +=0.5f;
    if (lightRotation > 360.0)
    	lightRotation -= 360.0;
    glutPostRedisplay();
}

int main(int argc, char* argv[])
{
    // intialise window parameters
	glutInit(&argc,argv);
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB |  GLUT_DEPTH); // double buffer for animation smoothness
    glutInitWindowSize(500,500);
    glutInitWindowPosition(100,150);

    // create main window
    window = glutCreateWindow("Rob's Animated 3D IIST");	// the main window
    glutReshapeFunc(myReshape);
    glutDisplayFunc(mainDisplay);
    glutSpecialFunc(arrowKeys);
    glutIdleFunc(idle);

    // create sub window for the text area
	textWindow = glutCreateSubWindow(window, 10,420, 480, 70); // startX, startY, width, height
    glutDisplayFunc(textDisplay);
    glutReshapeFunc(textReshape);

    // create sub window for the viewing area
    viewingWindow = glutCreateSubWindow(window, 10, 10, 480, 400);
    glutReshapeFunc(myReshape);
    glutDisplayFunc(display);
	glutSpecialFunc(arrowKeys);

    myInit();
    initTextures();	// setup textures

	createObjects();    // Call procedure to create the display list for the IIST logo
    redisplayAll();
    glutMainLoop();
}


